{% raw %}
kit-vlan {
    if ("%{Stripped-User-Domain}" =~ /^(kit.edu|)$/) {
        if (&Aruba-AP-Group) {
            if (&Aruba-AP-Group =~ /.+cs$/) {
                update reply {
{% endraw %}
                    Tunnel-Private-Group-Id := {{ vlan_policy.aruba_cs }}
                    Tunnel-Type := VLAN
                    Tunnel-Medium-Type := IEEE-802
                }
                update request {
                    Tmp-String-2 := "ARUBA|CS"
                }
        }
            else {
                update reply {
                    Tunnel-Private-Group-Id := {{ vlan_policy.aruba_cn }}
                    Tunnel-Type := VLAN
                    Tunnel-Medium-Type := IEEE-802
                }
                update request {
                    Tmp-String-2 := "ARUBA|CN"
                }
            }
        }
        elsif (&NAS-Identifier) {
            if (&NAS-Identifier == "HP-Cluster_cs") {
                update reply {
                    Tunnel-Private-Group-Id := {{ vlan_policy.hp_cs }}
                    Tunnel-Type := VLAN
                    Tunnel-Medium-Type := IEEE-802
                }
                update request {
                    Tmp-String-2 := "HP-CLUSTER|CS"
                }
            }
            elsif (&NAS-Identifier == "Trapeze") {
                update reply {
                    Tunnel-Private-Group-Id := {{ vlan_policy.atis }}
                    Tunnel-Type := VLAN
                    Tunnel-Medium-Type := IEEE-802
                }
                update request {
                    Tmp-String-2 := "ATIS-Controller|CS"
                }
            }
            else {
                update reply {
                    Tunnel-Private-Group-Id := {{ vlan_policy.hp_cn }}
                    Tunnel-Type := VLAN
                    Tunnel-Medium-Type := IEEE-802
                }
                update request {
                    Tmp-String-2 := "HP-CLUSTER|CN"
                }
            }
        }
    }{% raw %}
    elsif ("%{Stripped-User-Domain}" =~ /^gast\.kit\.edu$/) {
        if (&Aruba-AP-Group) {
            if (&Aruba-AP-Group =~ /.+cs$/) {
                update reply {
{% endraw %}
                    Tunnel-Private-Group-Id := {{ vlan_policy.aruba_cs_gast }}
                    Tunnel-Type := VLAN
                    Tunnel-Medium-Type := IEEE-802
                }
                update request {
                    Tmp-String-2 := "ARUBA|CS|GAST"
                }
            }
            else {
                update reply {
                    Tunnel-Private-Group-Id := {{ vlan_policy.aruba_cn_gast }}
                    Tunnel-Type := VLAN
                    Tunnel-Medium-Type := IEEE-802
                }
                update request {
                    Tmp-String-2 := "ARUBA|CN|GAST"
                }
            }
        }
        elsif (&NAS-Identifier) {
            if (&NAS-Identifier == "HP-Cluster_cs") {
                update reply {
                    Tunnel-Private-Group-Id := {{ vlan_policy.hp_cs_gast }}
                    Tunnel-Type := VLAN
                    Tunnel-Medium-Type := IEEE-802
                }
                update request {
                    Tmp-String-2 := "HP-CLUSTER|CS|GAST"
                }
            }
            elsif (&NAS-Identifier == "Trapeze") {
                update reply {
                    Tunnel-Private-Group-Id := {{ vlan_policy.atis_gast }}
                    Tunnel-Type := VLAN
                    Tunnel-Medium-Type := IEEE-802
                }
                update request {
                    Tmp-String-2 := "ATIS-Controller|CS|GAST"
                }
            }
            else {
                update reply {
                    Tunnel-Private-Group-Id := {{ vlan_policy.hp_cn_gast }}
                    Tunnel-Type := VLAN
                    Tunnel-Medium-Type := IEEE-802
                }
                update request {
                    Tmp-String-2 := "HP-CLUSTER|CN|GAST"
                }
            }
        }
    }{% raw %}
    elsif ("%{Stripped-User-Domain}" =~ /^([^\.]+)\.w2v\.kit\.edu$/) {
        if ("%{sql:SELECT COUNT(*) FROM w2v WHERE vlan_name=regexp_replace('%{Stripped-User-Domain}', '\.w2v\.kit\.edu$', '')}" > 0) {
######################################################################################################################################################################
# This is the right way, but LDAP-Group bug not fixed in our version: https://github.com/FreeRADIUS/freeradius-server/commit/e56048c98bfab25ae9453a52bbe6bcc02f20f515
#            # is user in group according to realm?
#            if (LDAP-Group == "%{sql:SELECT group_name FROM w2v WHERE vlan_name=regexp_replace('%{Stripped-User-Domain}', '\.w2v\.kit\.edu$', '')}") {
#                update reply {
#                    Tunnel-Private-Group-Id := "%{sql:SELECT vlan_id FROM w2v WHERE vlan_name=regexp_replace('%{Stripped-User-Domain}', '\.w2v\.kit\.edu$', '')}"
#                    Tunnel-Type := VLAN
#                    Tunnel-Medium-Type := IEEE-802
#                }
#                update request {
#                    Tmp-String-2 := "W2V|%{LDAP-Group}"
#                }
#            }
# this is the hacky way
            update request {
                Tmp-String-0 := "%{sql:SELECT group_name FROM w2v WHERE vlan_name=regexp_replace('%{Stripped-User-Domain}', '\.w2v\.kit\.edu$', '')}"
                Tmp-String-1 := "%{{% endraw %}ldap:{{ ldap_uri_group_check }}{% raw %}/ou=unix,ou=IDM,dc=kit,dc=edu?memberUid?sub?(&(cn=%{Tmp-String-0})(objectClass=posixGroup)(memberUid=%{%{Stripped-User-Name}:-%{User-Name}}))}"
            } 
            # is user in group according to realm?
            if (&Tmp-String-1 != "") {
                update reply {
                    Tunnel-Private-Group-Id := "%{sql:SELECT vlan_id FROM w2v WHERE vlan_name=regexp_replace('%{Stripped-User-Domain}', '\.w2v\.kit\.edu$', '')}"
                    Tunnel-Type := VLAN
                    Tunnel-Medium-Type := IEEE-802
                }
                update request {
                    Tmp-String-2 := "W2V|%{Tmp-String-0}"
                }
            }  
######################################################################################################################################################################
            else {
                update request {
                    Tmp-String-2 := "W2V|User not in Group"
                }
                reject
            }
        }
        else {
            update request {
                Tmp-String-2 := "W2V|Realm not in Database"
            }
            reject
        }
    }
    else {
       update request {
          Tmp-String-2 := "Realm not valid"
       }
       reject
    }
}

{% endraw %}
